/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@F18.5ԂR[h
                  gcc -lpthread -DCOLLECT_NUM=1 -DTHREAD_P=2
                     -DTHREAD_M1=2 -DTHREAD_M2=2 -DTHREAD_A=2 -o Program_3 Source_Program_3.c
  RpC@Fő̃R[h
                  gcc -lpthread -DCOLLECT_NUM=4096 -DTHREAD_P=2
                     -DTHREAD_M1=2 -DTHREAD_M2=2 -DTHREAD_A=2 -o Program_3 Source_Program_3.c
     COLLECT_NUMF1L[̃f[^w
        THREAD_PFSub_PickUp֐Xbh̎w
       THREAD_M1FSub_Mult1 ֐Xbh̎w
       THREAD_M2FSub_Mult2 ֐Xbh̎w
        THREAD_AFSub_AddChk֐Xbh̎w
  
*/
#include <stdio.h>
#include <malloc.h>
#include "Source_Program_3.h"
#define PATTERN  (0x0ABCDEF00)	// 6  
#define COUNT    (10)
#define STOP     (-1)
static int Loop1=0,Loop2=0;
static pthread_mutex_t       mutex_loop;
static pthread_mutex_t	     mutex_found;
static struct {int a,b;}     found[COUNT];
static volatile unsigned int count=COUNT;
static type_queue            que_init;

static int mul11(int a, int c) { return (a * c) << 16; }
static int mul12(int a, int d) { return (a * d) << 8; }
static int mul21(int c, int b) { return (c * b) << 8; }
static int mul22(int b, int d) { return (b * d); }
static int addAB(int A, int B) { return (A + B); }
static int addCD(int C, int D) { return (C + D); }
static int addEF(int E, int F) { return (E + F); }
static int check(int X) { return !(X ^ PATTERN); }

// L[̋󂫂҂āAf[^L[ɒǉ
void en_que(type_queue *q, type_data *datap)
{
  if (pthread_mutex_lock(&q->mutex) )
      printf(" Mutex Lock Error (%d)\n",__LINE__);
  while (q->counts == MAX_QUEUE_NUM)
    if ( pthread_cond_wait(&q->not_full, &q->mutex) )
        printf(" Mutex Wait Error (%d)\n",__LINE__);
        
  q->data[q->indx_w] = datap;
  q->indx_w++;
  if (q->indx_w == MAX_QUEUE_NUM)
    q->indx_w = 0;
  q->counts++;
  if ( pthread_cond_signal(&q->not_empty) )
      printf(" Mutex Cond Signal Error (%d)\n",__LINE__);
  if ( pthread_mutex_unlock(&q->mutex) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
}

// L[ɒl΃f[^oAΑ҂
void de_que(type_queue *q, type_data **datap)
{
  if ( pthread_mutex_lock(&q->mutex) )
      printf(" Mutex Lock Error (%d)\n",__LINE__);
  while (q->counts == 0)
    if ( pthread_cond_wait(&q->not_empty, &q->mutex) )
        printf(" Mutex Wait Error (%d)\n",__LINE__);
  *datap = q->data[q->indx_r];
  q->indx_r++;
  if (q->indx_r == MAX_QUEUE_NUM)
    q->indx_r = 0;
  q->counts--;
  if ( pthread_cond_signal(&q->not_full) )
      printf(" Mutex Cond Signal Error (%d)\n",__LINE__);
  if ( pthread_mutex_unlock(&q->mutex) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
}

void Sub_PickUp(void *p)
{
  type_arg *arg = (type_arg *)p;
  type_data *data;
  int i,j,k;

  for ( ; ; )
  {
    if ( !count )
      return;
    data = malloc(sizeof(type_data));
    if ( !data )
        printf(" Malloc Error (%d)\n",__LINE__);
    data->stop = 0;
    if ( pthread_mutex_lock(&mutex_loop) )
      printf(" Mutex Lock Error (%d)\n",__LINE__);
    for ( k = 0 ; k < COLLECT_NUM ; k++ )
    {
        j = Loop2++;
        i = Loop1;
        if ( j == 0xFFFF )
            Loop1++,Loop2=0;
        if ( i > 0xFFFF )
        {
            data->stop = STOP;
            en_que(arg->que_out,data);
            if ( pthread_mutex_unlock(&mutex_loop) )
                printf(" Mutex Unlock Error (%d)\n",__LINE__);
            return;
        }
        data->ary[k].i = i;
        data->ary[k].j = j;
    }
    if ( pthread_mutex_unlock(&mutex_loop) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
    for ( k = 0 ; k < COLLECT_NUM ; k++ )
    {
        i = data->ary[k].i;
        j = data->ary[k].j;
        data->ary[k].a = i >> 8;	// 1oCgo(ӏ)
        data->ary[k].b = i & 0xFF;	// 1oCgo(Ӊ)
        data->ary[k].c = j >> 8;	// 1oCgo(Eӏ)
        data->ary[k].d = j & 0xFF;	// 1oCgo(EӉ)
    }
    en_que(arg->que_out,data);
  } 
}
void Sub_Mult1(void *p)
{
  type_arg *arg = (type_arg *)p;
  type_data *data;
  int i;

  for ( ; count ; )
  {
    de_que(arg->que_in, &data);
    for ( i = 0 ; i < COLLECT_NUM ; i++ )
    {
        data->ary[i].D = mul22(data->ary[i].b,data->ary[i].d); // ZP(ʁ~)
        data->ary[i].B = mul12(data->ary[i].a,data->ary[i].d); // ZQ(ʁ~) << 8
    }
    en_que(arg->que_out,data);
    if ( data->stop == STOP )
      break;
  }
  return;
}
void Sub_Mult2(void *p)
{
  type_arg *arg = (type_arg *)p;
  type_data *data;
  int i;

  for ( ; count ; )
  {
    de_que(arg->que_in, &data);
    for ( i = 0 ; i < COLLECT_NUM ; i++ )
    {
        data->ary[i].C = mul21(data->ary[i].c,data->ary[i].b); // ZR(ʁ~) << 8
        data->ary[i].A = mul11(data->ary[i].a,data->ary[i].c); // ZS(ʁ~) << 16
    }
    en_que(arg->que_out,data);
    if ( data->stop == STOP )
      break;
  }
  return;
}
void Sub_AddChk(void *p)
{
  type_arg *arg = (type_arg *)p;
  type_data *data;
  unsigned int i,X;

  for ( ; count ; )
  {
    de_que(arg->que_in, &data);
    for ( i = 0 ; i < COLLECT_NUM ; i++ )
    {
        data->ary[i].F = addCD(data->ary[i].C,data->ary[i].D); // ZP(ZP{ZR)
        data->ary[i].E = addAB(data->ary[i].A,data->ary[i].B); // ZQ(ZQ{ZS)
        X = addEF(data->ary[i].E,data->ary[i].F);              // ZR(ZP{ZQ)
        if( check(X) )
        {
            count--;
            if ( pthread_mutex_lock(&mutex_found) )
                printf(" Mutex Lock Error (%d)\n",__LINE__);
            found[count].a = data->ary[i].i;
            found[count].b = data->ary[i].j;
            if ( pthread_mutex_unlock(&mutex_found) )
                printf(" Mutex Unlock Error (%d)\n",__LINE__);
            printf("%8.8X = %4.4X * %4.4X\n",X,data->ary[i].i,data->ary[i].j);
        }
    }
    if ( data->stop == STOP )
      break;
    free(data);
    data = NULL;
  }
  if (data)
    free(data);
  return;
}

void main(void)
{
  int        i;
  pthread_t  PickUp[THREAD_P];
  pthread_t  Mult1[THREAD_M1];
  pthread_t  Mult2[THREAD_M2];
  pthread_t  AddChk[THREAD_A];
  type_arg   PUarg[THREAD_P];
  type_arg   M1arg[THREAD_M1];
  type_arg   M2arg[THREAD_M2];
  type_arg   ACarg[THREAD_A];
  type_queue que1,que2,que3;

  // L[e[ȕ
  que1 = que2 = que3 = que_init;
  pthread_mutex_init(&que1.mutex, NULL);
  pthread_cond_init(&que1.not_full, NULL);
  pthread_cond_init(&que1.not_empty, NULL);
  pthread_mutex_init(&que2.mutex, NULL);
  pthread_cond_init(&que2.not_full, NULL);
  pthread_cond_init(&que2.not_empty, NULL);
  pthread_mutex_init(&que3.mutex, NULL);
  pthread_cond_init(&que3.not_full, NULL);
  pthread_cond_init(&que3.not_empty, NULL);
  pthread_mutex_init(&mutex_loop, NULL);
  pthread_mutex_init(&mutex_found, NULL);
  
  // PickUp_thread 
  for (i = 0 ; i < THREAD_P ; i++)
  {
    PUarg[i].id = i;
    PUarg[i].que_in  = 0;
    PUarg[i].que_out = &que1;
    if ( pthread_create(&PickUp[i], NULL, (void*)Sub_PickUp,(void*)&PUarg[i]) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  // Mult1_thread 
  for (i = 0 ; i < THREAD_M1 ; i++)
  {
    M1arg[i].id = i;
    M1arg[i].que_in  = &que1;
    M1arg[i].que_out = &que2;
    if ( pthread_create(&Mult1[i], NULL, (void*)Sub_Mult1,(void*)&M1arg[i]) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  // Mult2_thread 
  for (i = 0 ; i < THREAD_M2 ; i++)
  {
    M2arg[i].id = i;
    M2arg[i].que_in  = &que2;
    M2arg[i].que_out = &que3;
    if ( pthread_create(&Mult2[i], NULL, (void*)Sub_Mult2,(void*)&M2arg[i]) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  // AddChk_thread 
  for (i = 0 ; i < THREAD_A ; i++)
  {
    ACarg[i].id = i;
    ACarg[i].que_in  = &que3;
    ACarg[i].que_out = 0;
    if ( pthread_create(&AddChk[i], NULL, (void*)Sub_AddChk,(void*)&ACarg[i]) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  // AddChk_thread ̏I҂
  for (i = 0 ; i < THREAD_A ; i++) 
    pthread_join(AddChk[i], NULL);

  return;
}
